{$r+}
program taipan;

const bankzins = 0.001;
      wuzins   = 0.02;
      pause1   = 2000;
      pause2   = 3000;
      pause3   = 4000;
      pboom    = 4;
      pbuyship = 6;
      pwhouse  = 6;
      pbuygun  = 6;
      praub    = 30;
      pbrand   = 30;
      ppirates = 6;
      ppirnum  = 10;
      ptaifun  = 12;
      psink    = 10;
      pverlor  = 4;
      pumweg   = 2;


type ortt      = (Hongkong,Shanghai,Nagasaki,Saigon,Manila,Singapur,Batavia,See);
     warent    = (opium,gewuerze,seide,erz);
     schifft   = record
                   tonnage : integer;
                   status  : integer;
                   kanonen : byte;
                   ladung  : array[warent] of integer
                 end;
     lagert    = record
                   kapazitaet : integer;
                   inhalt  : array[warent] of integer
                 end;
     preiset   = array[warent] of real;
     hafent    = record
                   name  : ortt;
                   markt : preiset;
                   lager : lagert;
                   zoll  : byte; {invers zur Opiumkontrolle}
                 end;
     datumt    = record
                   tag   : 1..31;
                   monat : 1..12;
                   jahr  : 1800..1899;
                 end;
     charset   = set of char;
     string80  = string[80];

const ortstr   : array[ortt] of string[10] =
                 ('Hongkong','Shanghai','Nagasaki','Saigon  ','Manila  ',
                  'Singapur','Batavia ','Hohe See');
const entfernung : array[hongkong..batavia,hongkong..batavia] of integer =
               ((0,10,14,12,9,18,24),(10,0,5,22,16,27,32),(14,5,0,25,18,31,34),
                (12,22,25,0,11,21,13),(9,16,18,11,0,8,23),(18,27,31,21,8,0,7),
                (24,32,34,13,23,7,0));
const warenstr : array[warent] of string[10] =
                 ('Opium','Gewrze','Seide','Erz');

var  aufenthalt  : hafent;
     haefen      : array[ortt] of hafent;
     bar, kapital, schulden,inflation : real;
     firmname : string[20];
     schiff   : schifft;
     overburdened : boolean;
     datum        : datumt;
     tage         : integer;

procedure center (zeile:byte; meldung:string80);
begin
  gotoxy(1,zeile);
  clreol;
  gotoxy(40 - length(meldung) div 2,zeile);
  write(meldung);
end; {center}

procedure inverse;
begin
  textcolor(0);
  textbackground(7)
end;

procedure normal;
begin
  textcolor(7);
  textbackground(0);
end;

procedure hidecursor;
var regs : record
             ax,bx,cx,dx,bp,si,di,ds,es,flags : integer
           end;
begin
  regs.ax:= $0100;
  regs.cx:= $2000;
  intr(16,regs)
end;

procedure showcursor;
var regs : record
             ax,bx,cx,dx,bp,si,di,ds,es,flags : integer
           end;
begin
  regs.ax:= $0100;
  regs.cx:= $0c0d;
  intr(16,regs)
end;

function rnd (lower,upper : real) : real;
{return real >= lower and <= upper}
begin
  rnd:= lower + random * (upper-lower)
end;

function getkey(allowed : charset) : char;
var ch : char;
begin
  repeat read(kbd,ch); ch:= upcase(ch) until ch in allowed;
  write(ch);
  getkey:= ch
end; {getkey}

procedure readnumber(var n : integer);
label loop;
var s    : string[40];
    code : integer;
begin
loop:
  code:= 1;
  read(s);
  if (s = 'A') or (s = 'a') then
    n:= -1
  else if (s = 'T') or (s = 't') then
    n:= -2
  else
    begin
      val(s,n,code);
      if code <> 0 then goto loop
    end
end; {readnumber}

procedure readpreis(var r : real);
label loop;
var s    : string[40];
    code : integer;
begin
loop:
  code:= 1;
  read(s);
  val(s,r,code);
  if code <> 0 then goto loop
end;

procedure writepreis(r:real);
const mio   = 1000000.0;
var   m     : integer;
      s1,s2 : string[20];
begin
  if r < mio then
    write(r:10:0)
  else
    begin
      m:= 0;
      while r > mio do
        begin
          r:= r - mio;
          m:= m + 1
        end;
      str(m:0,s1);
      str(r:0:0,s2);
      while length(s2) < 6 do
        s2:= '0' + s2;
      s1:= s1 + '.' + s2;
      while length(s1) < 10 do
        s1:= ' ' + s1;
      write(s1)
    end
end; {writepreis}

procedure initmarket;
var ware      : warent;
begin
  with aufenthalt do
    begin
      markt[opium]:= rnd(5000,20000);
      markt[gewuerze]:= rnd(400,2000);
      markt[seide]:= rnd(40,200);
      markt[erz]:= rnd(6,30);
      if random(pboom) = 0 then {preissturz/boom}
        begin
          inverse; gotoxy(1,22); clreol;
          ware:= warent(random(4));
          if random(2) = 0 then
            begin
              markt[ware]:= markt[ware] * (random(6) + 4);
              write(' Preisboom fr ',warenstr[ware],' ! ')
            end
          else
            begin
              markt[ware]:= markt[ware] / (random(6) + 4);
              write(' Preissturz fr ',warenstr[ware],' ! ')
            end;
          delay(pause1);
          normal;
          gotoxy(1,22); clreol
        end;
      for ware:= opium to erz do
        markt[ware]:= markt[ware] + markt[ware] * inflation;
    end
end; {initmarket}

procedure initialize;
var ort  : ortt;
    i,j,zufall    : integer;
    zoll : array[1..7] of byte;
begin
  lowvideo;
  randomize;
  firmname:= 'Jentschis-Khan KG';
  with datum do
    begin
      tag:= 16;
      monat:= 11;
      jahr:= 1812
    end;
  tage:= 0;
  inflation:= 0.0;
  zoll[1]:= 2; zoll[2]:= 6; zoll[3]:= 6; zoll[4]:= 100;
  zoll[5]:= 100; zoll[6]:= 100; zoll[7]:= 100;
  for i:= 7 downto 2 do
    begin
      j:= random(7) + 1;
      zufall:= zoll[j];
      zoll[j]:= zoll[i];
      zoll[i]:= zufall
    end;
  for ort:= hongkong to batavia do
    begin
      haefen[ort].name:= ort;
      haefen[ort].lager.kapazitaet:= 0;
      haefen[ort].zoll:= zoll[ord(ort)+1];
    end;
  with haefen[hongkong].lager do
    begin
      kapazitaet:= 1000;
      inhalt[opium]:= 0;
      inhalt[gewuerze]:= 0;
      inhalt[seide]:= 0;
      inhalt[erz]:= 0
    end;
  with schiff do
    begin
      tonnage:= 80;
      status := 100;
      kanonen:= 3;
      ladung[opium]:= 0;
      ladung[gewuerze]:= 0;
      ladung[seide]:= 0;
      ladung[erz]:= 0;
    end;
  overburdened:= false;
  kapital:= 0;
  bar:= 3000;
  schulden:= 0;
  aufenthalt:= haefen[hongkong];
  initmarket;
end; {initialize}

procedure displaydate;
begin
  gotoxy(69,3);
  write('          ');
  gotoxy(69,3);
  with datum do
    write(tag:0,'.',monat:0,'.',jahr:0)
end; {displaydate}

procedure incrementdate(days:integer);
var t,m,j : integer;
begin
  tage:= tage + days;
  with datum do
    begin
      t:= tag + days;
      m:= monat;
      while t > 30 do
        begin
          t:= t - 30;
          m:= m + 1;
        end;
      tag:= t;
      while m > 12 do
        begin
          m:= m - 12;
          jahr:= jahr + 1
        end;
      monat:= m
    end;
  displaydate;
  kapital:= kapital + days * bankzins * kapital;
  schulden:= schulden + days * wuzins * schulden;
  inflation:= (tage div 100) * 0.1;
  {auch Schulden um Zinsen vermehren, Zinsen sind Teil des Marktes!}
end; {incrementdate}

procedure displaylocation;
begin
  gotoxy(69,5);
  inverse;
  case aufenthalt.name of
    hongkong     : write(' Hongkong ');
    shanghai     : write(' Shanghai ');
    nagasaki     : write(' Nagasaki ');
    saigon       : write(' Saigon   ');
    manila       : write(' Manila   ');
    singapur     : write(' Singapur ');
    batavia      : write(' Batavia  ');
    see          : write(' Hohe See ');
  end;
  normal;
end; {displaylocation}

procedure displaydebt;
begin
  gotoxy(61,17);
  writepreis(schulden)
end;

procedure displaycash;
begin
  gotoxy(10,17);
  writepreis(bar)
end;

procedure displaybank;
begin
  gotoxy(36,17);
  writepreis(kapital)
end;

procedure displaystatus;
var lagerbelegt, schiffbelegt : integer;
begin
  displaycash;
  displaybank;
  displaydebt;
  with aufenthalt.lager do
    if kapazitaet > 0 then
      begin
        gotoxy(4,3); inverse; write(' Lagerhaus:     '); normal;
        gotoxy(4,4); write('Opium...... ',inhalt[opium]:6);
        gotoxy(4,5); write('Gewrze.... ',inhalt[gewuerze]:6);
        gotoxy(4,6); write('Seide...... ',inhalt[seide]:6);
        gotoxy(4,7); write('Erz........ ',inhalt[erz]:6);
        lagerbelegt:= inhalt[opium] + inhalt[gewuerze] + inhalt[seide] +
                      inhalt[erz];
        gotoxy(33,4); write('Frei...... ',kapazitaet - lagerbelegt:6);
      end
    else
      begin
        Gotoxy(4,3); inverse; write(' Kein Lagerhaus '); normal;
        gotoxy(4,4); write('                                              ');
        gotoxy(4,5); write('                                              ');
        gotoxy(4,6); write('                                              ');
        gotoxy(4,7); write('                                              ');
      end;
  with schiff do
    begin
      gotoxy(16,11); write(ladung[opium]:6);
      gotoxy(16,12); write(ladung[gewuerze]:6);
      gotoxy(16,13); write(ladung[seide]:6);
      gotoxy(16,14); write(ladung[erz]:6);
      schiffbelegt:= ladung[opium] + ladung[gewuerze] + ladung[seide] +
                     ladung[erz] + kanonen * 10;
      gotoxy(45,11);
      if schiffbelegt <= tonnage then
        begin
          overburdened:= false;
          write('         ');
          gotoxy(45,11);
          write(tonnage - schiffbelegt:6)
        end
      else
        begin
          overburdened:= true;
          inverse; write('berladen'); normal
        end;
      gotoxy(45,12); write(kanonen:6);
      gotoxy(45,14); write(status:6)
    end;
end; {displaystatus}

procedure displayframe;
{maske}
begin
clrscr;
center(1,'Firma ' + firmname  + ' Hongkong');
writeln;
writeln('ͻ');
writeln('                                                           Datum:');
writeln('                                                         ');
writeln('                                                           Ort:');
writeln('                                                         ');
writeln('                                                         ');
writeln('                                                         ');
writeln('Ķ');
writeln('  Schiff:                                                ');
writeln('  Opium......                  Frei.......               ');
writeln('  Gewrze....                  Kanonen....               ');
writeln('  Seide......                                            ');
writeln('  Erz........            Seetchtigkeit...               ');
writeln('                                                         ');
writeln('ͼ');
writeln('Bargeld:                Bankkonto:                Schulden:');
writeln('');
displaydate;
displaylocation;
displaystatus
end; {displayframe}

procedure clearcommarea;
begin
  gotoxy(1,23); clreol;
  gotoxy(1,25); clreol;
  gotoxy(1,24); clreol
end; {clearcommarea}

procedure clearmsgarea;
begin
  gotoxy(1,20); clreol;
  gotoxy(1,21); clreol;
  gotoxy(1,22); clreol;
end; {clearmsgarea}

procedure clearheading;
begin
  gotoxy(1,19); clreol
end;

procedure agentreport;
begin
  clearheading;
  inverse;
  write('Dein Agent berichtet:');
  normal
end; {agentreport}

procedure captainreport;
begin
  clearheading;
  inverse;
  write('Dein Steuermann berichtet:');
  normal
end; {captainreport}

procedure displaymessage (msg : string80);
begin
  gotoxy(1,20);
  write(msg);
  delay(pause1);
  gotoxy(1,20); clreol
end; {displaymessage}

procedure displaymarket;
{preise im hafen}
begin
  agentreport;
  gotoxy(1,20); clreol;
  writeln('Taipan, die Preise sind hier im Moment:');
  with aufenthalt do
  writeln('Opium: ',markt[opium]:8:0,'   Gewrze: ',markt[gewuerze]:7:0,
          '   Seide: ',markt[seide]:5:0,'   Erz: ',markt[erz]:4:0);

end; {displaymarket}

procedure messages;
{at arrival: also buy guns,li yuen etc}
var preis : real;
    groesse : integer;
    ware    : warent;
begin
  clearmsgarea;
  {buy bigger ship}
  if (random(pbuyship) = 0) and (bar > 80000.0) then
    begin
      preis:= rnd(3000.0,100000.0);
      if schiff.status < 100 then
        preis:= preis * (100-schiff.status) * 0.1;
      write('Taipan, willst Du ein greres Schiff fr ',preis:0:0,' kaufen? ');
      case getkey(['J','N']) of
        'J' : begin
                bar:= bar - preis;
                schiff.tonnage:= schiff.tonnage + 30 + random(60);
                schiff.status:= 100
              end;
      end;
      clearmsgarea;
    end;
  {buy guns}
  if (random(pbuygun) = 0) and (bar > 50000.0) then
    begin
      preis:= rnd(150.0,12000.0);
      write('Hier wird eine Kanone fr ',preis:0:0,' angeboten. Schlagen wir zu? ');
      case getkey(['J','N']) of
        'J' : begin
                bar:= bar - preis;
                schiff.kanonen:= schiff.kanonen + 1
              end
      end;
      clearmsgarea;
    end;
  {enlarge warehouse}
  if (random(pwhouse) = 0) and (bar > 1000000.0) then
    begin
      preis:= rnd(300000.0,1000000.0);
      write('Du kannst Dein Lager erweitern fr ',preis:0:0,' Pfund, Taipan! ');
      case getkey(['J','N']) of
        'J' : begin
                with aufenthalt.lager do
                  begin
                    bar:= bar - preis;
                    if kapazitaet = 0 then
                      for ware:= opium to erz do
                        inhalt[ware]:= 0;
                    kapazitaet:= kapazitaet + random(800) + 100;
                  end;
              end;
      end;
      clearmsgarea;
    end;
  {opium razzia}
  if (schiff.ladung[opium] > 0) and (random(aufenthalt.zoll) = 0) then
    begin
      preis:= rnd(bar/4,bar);
      writeln('Die Hafenbehrde hat alles Opium beschlagnamt.');
      write('Wir mssen ',preis:0:0,' Pfund Strafe zahlen!');
      delay(pause1);
      schiff.ladung[opium]:= 0;
      bar:= bar - preis;
      clearmsgarea;
    end;
  {ruber}
  if random(praub) = 0 then
    begin
      preis:= rnd(bar/10,bar);
      write('Wir sind berfallen worden. Man hat uns ',preis:0:0,' Pfund geraubt!');
      delay(pause1);
      bar:= bar - preis;
      clearmsgarea
    end;
  {brand im lagerhaus}
  if (aufenthalt.lager.kapazitaet > 0) and (random(pbrand) = 0) then
    with aufenthalt.lager do
      begin
        groesse:= random(kapazitaet);
        write('Ein Brand hat das Lagerhaus verwstet!');
        delay(pause1);
        kapazitaet:= kapazitaet - groesse;
        if kapazitaet < 0 then kapazitaet:= 0;
        for ware:= opium to erz do
          inhalt[ware]:= inhalt[ware] div (random(5) + 1);
        clearmsgarea;
      end;
  displaystatus
end; {messages}

procedure askgood(var ware : warent);
begin
  case getkey(['O','G','S','E']) of
    'O' : ware:= opium;
    'G' : ware:= gewuerze;
    'S' : ware:= seide;
    'E' : ware:= erz;
  end;
end; {askgood}

procedure calcerror;
begin
  gotoxy(1,25); clreol;
  write('Taipan, Du hast Dich verrechnet!');
  delay(pause1);
  gotoxy(1,25); clreol;
end; {calcerror}

procedure buy;
label exit;
var number,imax  : integer;
    max     : real;
    toomuch : boolean;
    good    : warent;
begin
  clearcommarea;
  write('Was soll ich kaufen, Taipan? ');
  askgood(good);
  max:= int(bar/aufenthalt.markt[good]);
  if max < maxint then
    imax:= trunc(max)
  else
    imax:= maxint;
  repeat
    gotoxy(1,24); clreol;
    write('Du kannst ',max:0:0,' bezahlen.     ');
    toomuch:= false;
    write('Wieviel ',warenstr[good],' soll ich kaufen? ');
    readnumber(number);
    if number = 0 then goto exit
    else if number > max then
      begin
        toomuch := true;
        calcerror
      end
  until not toomuch;
  if number = -1 then number:= imax
  else if number = -2 then with schiff do
    begin
      number:= tonnage-ladung[opium]-ladung[gewuerze]
               -ladung[seide]-ladung[erz]-kanonen*10;
      if number > imax then number:= imax
    end;
  bar:= bar - number * aufenthalt.markt[good];
  schiff.ladung[good]:= schiff.ladung[good] + number;
exit:
end; {buy}

procedure sell;
label exit;
var number,max  : integer;
    good    : warent;
    toomuch : boolean;
begin
  clearcommarea;
  write('Was soll ich verkaufen, Taipan? ');
  askgood(good);
  max:= schiff.ladung[good];
  repeat
    gotoxy(1,24); clreol;
    write('Wieviel ',warenstr[good],' soll ich verkaufen? ');
    toomuch:= false;
    readnumber(number);
    if number > max then
      begin
        toomuch:= true;
        calcerror
      end;
  until not toomuch;
  if number = 0 then goto exit
  else if number < 0 then number:= max;
  bar:= bar + number * aufenthalt.markt[good];
  schiff.ladung[good]:= schiff.ladung[good] - number;
exit:
end; {sell}

procedure lagere;
{store in warehouse}
var good   : warent;
    number,inh : integer;
    toomuch: boolean;
begin
  clearcommarea;
  write('Was soll ins Lagerhaus? ');
  askgood(good);
  with aufenthalt.lager,schiff do
  begin
    inh:= inhalt[opium] + inhalt[gewuerze] + inhalt[seide] + inhalt[erz];
    repeat
      toomuch:= true;
      gotoxy(1,24); clreol;
      write('Wieviel ',warenstr[good],'? ');
      readnumber(number);
      toomuch:= (number > ladung[good]) or (inh + number > kapazitaet);
      if toomuch then calcerror
    until not toomuch;
    if number < 0 then
      if ladung[good] + inh > kapazitaet then
        number:= kapazitaet - inh
      else
        number:= ladung[good];
    ladung[good]:= ladung[good] - number;
    inhalt[good]:= inhalt[good] + number
  end {with}
end; {lagere}

procedure entnehme;
{get from warehouse}
var good   : warent;
    number : integer;
    toomuch: boolean;
begin
  clearcommarea;
  write('Was soll an Bord? ');
  askgood(good);
  with aufenthalt.lager,schiff do
    begin
      repeat
        toomuch:= true;
        gotoxy(1,24); clreol;
        write('Wieviel ',warenstr[good],'? ');
        readnumber(number);
        toomuch:= (number > inhalt[good]);
        if toomuch then calcerror
      until not toomuch;
      if number = -1 then number:= inhalt[good]
      else if number = -2 then
        begin
          number:= tonnage-ladung[opium]-ladung[gewuerze]
                   -ladung[seide]-ladung[erz]-kanonen*10;
          if number > inhalt[good] then number:= inhalt[good]
        end;
      ladung[good]:= ladung[good] + number;
      inhalt[good]:= inhalt[good] - number
    end {with}
end; {entnehme}

procedure spare;
var betrag  : real;
    toomuch : boolean;
begin
  clearcommarea;
  repeat
    gotoxy(1,24); clreol;
    write('Wieviel soll aufs Konto? ');
    toomuch:= false;
    readpreis(betrag);
    toomuch:= betrag > bar;
    if toomuch then calcerror
  until not toomuch;
  bar:= bar - betrag;
  kapital:= kapital + betrag
end; {spare}

procedure hebeab;
var betrag  : real;
    toomuch : boolean;
begin
  clearcommarea;
  repeat
    gotoxy(1,24); clreol;
    write('Wieviel soll ich abheben? ');
    toomuch:= false;
    readpreis(betrag);
    toomuch:= betrag > kapital;
    if toomuch then calcerror
  until not toomuch;
  bar:= bar + betrag;
  kapital:= kapital - betrag;
end; {gobank}

procedure borrow;
{from elder brother wu}
begin
  gotoxy(1,24); clreol;
  write('Der alte Halsabschneider Wu hlt sich versteckt.');
  delay(pause1);
  gotoxy(1,24); clreol
end; {borrow}

procedure pirates(var days: integer);
var n : integer;
begin
  if random(ppirates) = 0 then
    begin
      n:= random(ppirnum) * (schiff.tonnage div 100);
      if n > 2 then
        begin
          displaymessage(' P i r a t e n  ! !       ');
          write(n,' Schiffe greifen uns an!');
          delay(pause1);
          gotoxy(1,20); clreol;
          days:= days + n div 10;
          schiff.status:= schiff.status - random(n);
          if schiff.status < 3 then
            begin
              displaymessage('Wir sinken !!!');
              halt
            end;
        end
    end;
end; {pirates}

procedure hazards(var i,days : integer);
{misfortune while on sea}
begin
  pirates(days);
  if random(ptaifun)= 0 then
    begin
      displaymessage(' E i n   T a i f u n  ! ! ');
      days:= days + 5;
      schiff.status:= schiff.status - random(10);
      if random(psink) = 0 then
        begin
          delay(pause2);
          displaymessage(' Wir sind schwer angeschlagen! Wir werden sinken !!! ');
          if schiff.status > 50 then
            schiff.status:= schiff.status div 2
          else if schiff.status < 3 then
            begin
              displaymessage('Wir sind verloren !!');
              halt
            end
          else
            schiff.status:= schiff.status div 4;
          days:= days + 20;
          delay(pause3);
          if random(pverlor) = 0 then
            begin
              displaymessage(' W I R   S I N D   V E R L O R E N ,   T A I P A N ');
              halt
            end
          else
            write(' W i r   h a b e n   e s   g e s c h a f f t   ! ! ! ');
        end;
      if random(pumweg) = 0 then
        begin
          delay(pause1);
          i:= random(7) + 1;
          gotoxy(1,20); clreol;
          write(' Wir sind nach ',ortstr[ortt(i-1)],' verschlagen worden ! ');
          delay(pause1);
          gotoxy(1,20); clreol;
          days:= days + 5;
        end;
      delay(pause2);
    end;
  normal
end; {hazards}

procedure travel;
label loop, exit;
var i, code : integer;
    days    : integer;
    ch      : char;
begin
  if overburdened then goto exit;
loop :
  clearmsgarea; clearcommarea;
  write('1:Hongkong 2:Shanghai 3:Nagasaki 4:Saigon 5:Manila 6:Singapur 7:Batavia  ');
  ch:= getkey(['1'..'7']);
  clearcommarea;
  val(ch,i,code);
  if ortt(i-1) = aufenthalt.name then
    begin
      gotoxy(1,20); clreol;
      write('Taipan, Du bist betrunken! Wir sind doch in ',ortstr[aufenthalt.name],' !');
      delay(pause1);
      gotoxy(1,21); clreol;
      goto loop
    end
  else
    begin
      haefen[aufenthalt.name]:= aufenthalt;
      days:= entfernung[aufenthalt.name,ortt(i-1)];
      aufenthalt.name:= see;
    end;
  gotoxy(1,19); clreol;
  displaylocation;
  delay(pause1);
  captainreport;
  hazards(i,days);
  aufenthalt:= haefen[ortt(i-1)];
  gotoxy(1,20); clreol;
  write('Wir sind nach ',days:0,' Tagen in ',ortstr[aufenthalt.name],' gelandet, Taipan!');
  delay(pause1);
  gotoxy(1,20); clreol;
  incrementdate(days);
  displaylocation;
  initmarket;
  messages;
  displaymarket;
exit:
end; {travel}

procedure asktransaction;
var allowed : charset;
begin
  clearcommarea;
  inverse;
  write('K)aufe V)erkaufe ');
  if aufenthalt.name = hongkong then
  {ask also Repair Vacation...}
    begin
      write('L)agere E)ntnehme S)pare H)ebeab W)u A)uslaufen   --> ');
      allowed:= ['K','V','L','E','S','H','W','A']
    end
  else
    begin
      allowed:= ['K','V','A'];
      if aufenthalt.lager.kapazitaet > 0 then
        begin
          allowed:= allowed + ['L','E'];
          write('L)agere E)ntnehme ')
        end;
      write('A)uslaufen   --> ')
    end;
  normal;
  case getkey(allowed) of
    'K' : buy;
    'V' : sell;
    'L' : lagere;
    'E' : entnehme;
    'S' : spare;
    'H' : hebeab;
    'A' : travel;
    'W' : borrow
  end;
  displaystatus
end; {asktransaction}


begin  { m a i n }
  initialize;
  displayframe;
  displaymarket;
  repeat
    asktransaction;
  until false;
end.